<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\Manager;

class KdsMensagemDias extends Crud {
    
    protected $dataSourceName = 'kdsMgsDias';
    protected $utilService;
    protected $service;
    
    public function __construct (Manager $manager,Utilities\Util $utilService, Services\KdsMensagemDias $service){
        $this->service = $service;
        $this->utilService = $utilService;
        parent::__construct($manager);
    }
    
    public function saveDias (DTO\Request\Row $request, DTO\Response $response){
        $conditions = $this->utilService->getParamsAsArray($request);
        $result = $this->service->saveDias($conditions);
        $response->addDataSet(new DataSet($this->dataSourceName, array('STATUS'=>$result)));
    }
}