<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;

use Teknisa\MAN\Services\LojaParametrizacaoLimiteOcorrencia;

class LojaParametrizacaoLimiteOcorrenciaController extends CrudWithParameterBag {

    protected $dataSourceName = 'ger12300_cadloja_parametrizacao_limite_ocorrencia';
    protected $parameterBagColumns = array('CDFILIAL', 'CDLOJA', 'NRORG');
    protected $limiteOcorrService;
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService, LojaParametrizacaoLimiteOcorrencia $limiteOcorrService) {
        $this->utilService = $utilService;
        parent::__construct($dataSourceManager, $parameterBag);
        $this->limiteOcorrService = $limiteOcorrService;
    }
    
    public function saveLimite(DTO\Request\DataSet $request, DTO\Response $response) {
        $data = $this->utilService->getParamsAsArray($request);
        $this->limiteOcorrService->saveLimite($data);
    }
    
}