<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelControleDeMovimentacaoService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function controleDeMovimentacaoParamBuild($conditions){
        
       $thisDate = array(
           'MES' => explode('/', $conditions['DTINICIAL'])[0],
           'ANO' => explode('/', $conditions['DTINICIAL'])[1]
       );
        
       $diaPrimeiroMes = '01'.'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
       $ultimoDiaMes = date('t', strtotime(str_replace("/", "-", $diaPrimeiroMes))).'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
        
       $params = array (      
            ':CDFILIAL'       => (isset($conditions['CDFILIAL'])) ? (implode('_', $conditions['CDFILIAL'])) : null,
            ':TCDFILIAL'      => (!isset($conditions['CDFILIAL'])) ? 'T' : null,
            ':CDFILICAIXA'        => (isset($conditions['CDFILICAIXA'])) ? (implode('_', $conditions['CDFILICAIXA'])) : null,
            ':TCDCAIXA'       => (!isset($conditions['CDFILICAIXA'])) ? 'T' : null,
            ':DTINICIAL'      => $diaPrimeiroMes,
            ':DTFINAL'        => $ultimoDiaMes
        );
        return $this->entityManager->getConnection()->fetchAll(self::CONTROLE_DE_MOVIMENTACAO_QRY, $params);
    }
    
    const CONTROLE_DE_MOVIMENTACAO_QRY = "
        SELECT B.*, 
        (CASE 
           WHEN (B.DTMOVIMCAIXA IS NULL AND B.DTFERIFILI IS NOT NULL) THEN 'NN'   
           WHEN (B.DTMOVIMCAIXA IS NOT NULL AND B.DTFERIFILI IS NOT NULL) THEN 'NT'
           WHEN (B.DTMOVIMCAIXA IS NULL AND B.DTFERIFILI IS NULL) THEN 'TN'
           WHEN (B.DTMOVIMCAIXA IS NOT NULL AND B.DTFERIFILI IS NULL) THEN 'TT'
        END) LEGENDA
        
        FROM (SELECT DT.DTDATA, DT.NRORG, F.CDFILIAL, F.NMFILIAL, (F.CDFILIAL || '-' || F.NMFILIAL) AS UNIDADE, C.CDCAIXA, MC.DTMOVIMCAIXA, FF.DTFERIFILI 
        FROM ( SELECT DT.DTDATA, DT.NRORG FROM DATA DT  WHERE DT.DTDATA BETWEEN :DTINICIAL AND :DTFINAL  ORDER BY DT.DTDATA) DT
        INNER JOIN FILIAL F ON (F.NRORG = DT.NRORG)
        INNER JOIN CAIXA C ON (F.CDFILIAL = C.CDFILIAL)
        LEFT JOIN (SELECT MC.CDFILIAL, MC.CDCAIXA, MC.DTMOVIMCAIXA 
        FROM MOVCAIXA MC 
        WHERE MC.DTMOVIMCAIXA BETWEEN :DTINICIAL AND :DTFINAL 
        AND ((INSTR(:CDFILIAL, MC.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
        AND ((INSTR(:CDFILICAIXA, MC.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
        GROUP BY MC.CDFILIAL, MC.CDCAIXA, MC.DTMOVIMCAIXA 
        ORDER BY MC.DTMOVIMCAIXA, MC.CDFILIAL, MC.CDCAIXA ) MC ON (MC.DTMOVIMCAIXA = DT.DTDATA AND C.CDFILIAL = MC.CDFILIAL AND C.CDCAIXA = MC.CDCAIXA)
        LEFT JOIN FERIFILI FF ON (FF.CDFILIAL = C.CDFILIAL AND DT.DTDATA = FF.DTFERIFILI)
        WHERE ((INSTR(:CDFILIAL, C.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
        AND ((INSTR(:CDFILICAIXA, C.CDFILIAL||C.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
        ORDER BY DT.DTDATA, C.CDFILIAL, C.CDCAIXA) B
    ";
}